<script setup lang="ts">
import { onMounted, ref, useAttrs, reactive, watch } from "vue";
import { useRoute } from "vue-router";
import { useQuasar } from "quasar";
import axios from "axios";
import type { QTableProps } from "quasar";
import http from "@/plugins/http";
import config from "@/app.config";
import dialogHeader from "@/components/DialogHeader.vue";
import { useCounterMixin } from "@/stores/mixin";
import type { ResponseObject } from "@/components/information/interface/response/OldName";
import type { Pagination } from "@/modules/04_registryNew/interface/index/Main";
import type { RequestItemsObject } from "@/components/information/interface/request/OldName";
import { useProfileDataStore } from "@/modules/04_registryNew/stores/profile";

const $q = useQuasar();
const route = useRoute();
const mixin = useCounterMixin();
const store = useProfileDataStore();
const attrs = ref<any>(useAttrs());
const {
  date2Thai,
  success,
  dialogConfirm,
  messageError,
  showLoader,
  hideLoader,
  dialogRemove,
} = mixin;
const submitDisable = ref<boolean>(true);
const { fetchPerson } = store;
const profileId = ref<string>(route.params.id.toString());
const editId = ref<string>("");
const dialog = ref<boolean>(false);
const dialogStatus = ref<string>("create");
const filterSearch = ref("");
const filterHistory = ref<string>("");
const historyDialog = ref<boolean>(false);
const historyKeyword = ref<string>("");
const rowsHistory = ref<RequestItemsObject[]>([]);
const changeNameData = reactive<any>({
  profileId: profileId.value,
  prefixId: "",
  prefix: "",
  firstName: "",
  lastName: "",
  status: "",
  documentId: "",
});
const prefixChange = ref<string>("");
const firstNameChange = ref<string>("");
const lastNameChange = ref<string>("");

const profileInfo = ref<any>([]);

const statusOption = ref([
  "เปลี่ยนคำนำหน้าชื่อ",
  "เปลี่ยนชื่อ",
  "เปลี่ยนนามสกุล",
  "เปลี่ยนชื่อ-นามสกุล",
  "เปลี่ยนคำนำหน้าชื่อ และชื่อ",
  "เปลี่ยนคำนำหน้าชื่อ และนามสกุล",
  "เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล",
]);
const statusOptionFilter = ref([
  "เปลี่ยนคำนำหน้าชื่อ",
  "เปลี่ยนชื่อ",
  "เปลี่ยนนามสกุล",
  "เปลี่ยนชื่อ-นามสกุล",
  "เปลี่ยนคำนำหน้าชื่อ และชื่อ",
  "เปลี่ยนคำนำหน้าชื่อ และนามสกุล",
  "เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล",
]);
const alertUpload = ref<boolean>(false);
const tittleHistory = ref<string>("ประวัติการเปลี่ยนชื่อ-นามสกุล");
const visibleColumns = ref<string[]>([
  "prefix",
  "firstName",
  "lastName",
  "status",
]);
const historyVisibleColumns = ref<String[]>([
  "prefix",
  "firstName",
  "lastName",
  "status",
  "lastUpdateFullName",
  "lastUpdatedAt",
]);
const rows = ref<ResponseObject[]>([]);
const historyRows = ref<ResponseObject[]>([]);

const columns = ref<QTableProps["columns"]>([
  {
    name: "prefix",
    align: "left",
    label: "คำนำหน้าชื่อ",
    sortable: true,
    field: "prefix",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "firstName",
    align: "left",
    label: "ชื่อ",
    sortable: true,
    field: "firstName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastName",
    align: "left",
    label: "นามสกุล",
    sortable: true,
    field: "lastName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "status",
    align: "left",
    label: "สถานะการเปลี่ยนชื่อ",
    sortable: true,
    field: "status",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const historyColumns = ref<QTableProps["columns"]>([
  {
    name: "prefix",
    align: "left",
    label: "คำนำหน้าชื่อ",
    sortable: true,
    field: "prefix",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "firstName",
    align: "left",
    label: "ชื่อ",
    sortable: true,
    field: "firstName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastName",
    align: "left",
    label: "นามสกุล",
    sortable: true,
    field: "lastName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "status",
    align: "left",
    label: "สถานะการเปลี่ยนชื่อ",
    sortable: true,
    field: "status",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdateFullName",
    align: "left",
    label: "ผู้ดำเนินการ",
    sortable: true,
    field: "lastUpdateFullName",
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "lastUpdatedAt",
    align: "left",
    label: "วันที่แก้ไข",
    sortable: true,
    field: "lastUpdatedAt",
    format: (v) => date2Thai(v),
    headerStyle: "font-size: 14px",
    style: "font-size: 14px",
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
]);
const uploadUrl = ref<string>("");
const initialPagination = ref<Pagination>({
  rowsPerPage: 0,
});
const subId = ref<string>("");
const fileUpload = ref<File>();
const pagination = ref({
  page: 1,
  rowsPerPage: 10,
});

const historyPagination = ref({
  page: 1,
  rowsPerPage: 10,
});

function editForm(row: any) {
  submitDisable.value = true;
  dialogStatus.value = "edit";
  editId.value = row.id;
  subId.value = row.id;
  changeNameData.prefix = row.prefix;
  changeNameData.firstName = row.firstName;
  changeNameData.lastName = row.lastName;
  changeNameData.status = row.status;
  prefixChange.value = changeNameData.prefix;
  firstNameChange.value = changeNameData.firstName;
  lastNameChange.value = changeNameData.lastName;
  dialog.value = true;
}

function closeDialog() {
  alertUpload.value = false;
  dialog.value = false;
}

async function onSubmit() {
  if (!!fileUpload.value || dialogStatus.value === "edit") {
    await dialogConfirm(
      $q,
      async () => {
        showLoader();
        dialogStatus.value === "create"
          ? await addData()
          : await editData(editId.value);
        closeDialog();
        if (!!fileUpload.value) {
          await uploadProfile(fileUpload.value);
        }
      },
      "ยืนยันการบันทึกข้อมูล",
      "ต้องการยืนยันการบันทึกข้อมูลนี้หรือไม่ ?"
    );
  }
}

async function uploadProfile(file: File | undefined) {
  await http
    .post(
      config.API.subFile(
        "ทะเบียนประวัติ",
        "ประวัติการเปลี่ยนชื่อ-นามสกุล",
        profileId.value,
        subId.value
      ),
      {
        replace: true,
        fileList: [
          {
            fileName: "เอกสารหลักฐาน",
          },
        ],
      }
    )
    .then(async (res) => {
      uploadUrl.value = res.data["เอกสารหลักฐาน"].uploadUrl;
      uploadFileURL(uploadUrl.value, file);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function uploadFileURL(uploadUrl: string, file: any) {
  showLoader();
  await axios
    .put(uploadUrl, file, {
      headers: {
        "Content-Type": file.type,
      },
    })
    .then(() => {
      // fetchProfile(profileId.value);
      // success($q, "อัปโหลดไฟล์สำเร็จ");
      fileUpload.value = undefined;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function fetchDataPersonal() {
  showLoader();
  await http
    .get(config.API.registryNewByProfileId(profileId.value))
    .then((res) => {
      profileInfo.value = res.data.result;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function fetchProfile(id: string) {
  showLoader();
  await http
    .get(
      config.API.subFileByFileName(
        "ทะเบียนประวัติ",
        "ประวัติการเปลี่ยนชื่อ-นามสกุล",
        profileId.value,
        id,
        "เอกสารหลักฐาน"
      )
    )
    .then(async (res) => {
      const data = res.data.downloadUrl;
      window.open(data, "_blank");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function addData() {
  await http
    .post(config.API.profileNewChangeName, {
      ...changeNameData,
    })
    .then((res) => {
      subId.value = res.data.result;

      fetchData(profileId.value);
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

function editData(idData: string) {
  http
    .patch(config.API.profileNewChangeNameByChangeNameId(idData), {
      ...changeNameData,
      profileId: undefined,
    })
    .then(() => {
      fetchData(profileId.value);
      success($q, "บันทึกข้อมูลสำเร็จ");
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

// function deleteData(idData: string) {
//   dialogRemove($q, () =>
//     http
//       .delete(config.API.profileNewChangeNameByChangeNameId(idData))
//       .then(() => {
//         fetchData(profileId.value);
//         success($q, "ลบข้อมูลสำเร็จ");
//       })
//       .catch((err) => {
//         messageError($q, err);
//       })
//       .finally(() => {
//         hideLoader();
//       })
//   );
// }

function deleteFileData(idData: string) {
  http
    .delete(
      config.API.subFile(
        "ทะเบียนประวัติ",
        "ประวัติการเปลี่ยนชื่อ-นามสกุล",
        profileId.value,
        idData
      )
    )
    .then(() => {
      fetchData(profileId.value);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

async function fetchHistoryData(id: string) {
  showLoader();
  await http
    .get(config.API.profileNewChangeNameHisByChangeNameId(id))
    .then(async (res) => {
      historyRows.value = res.data.result;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

const paginationLabel = (start: string, end: string, total: string) => {
  return start + "-" + end + " ใน " + total;
};

async function openFile(val: string | null) {
  if (val != null) window.open(val);
}

function closeHistoryDialog() {
  historyDialog.value = false;
}

async function fetchData(id: string) {
  showLoader();
  await http
    .get(config.API.profileNewChangeNameByProfileId(id))
    .then(async (res) => {
      rows.value = res.data.result;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

onMounted(async () => {
  if (
    store.Ops.prefixOps.length === 0 ||
    store.Ops.genderOps.length === 0 ||
    store.Ops.bloodOps.length === 0 ||
    store.Ops.statusOps.length === 0 ||
    store.Ops.religionOps.length === 0
  ) {
    await fetchPerson();
  }

  fetchData(profileId.value);
  fetchDataPersonal();
});
function filterSelector(val: string, update: Function, refData: string) {
  switch (refData) {
    case "statusOptions":
      update(() => {
        statusOption.value = statusOptionFilter.value.filter(
          (v: any) => v.indexOf(val) > -1
        );
      });
      break;
    case "prefixOps":
      update(() => {
        store.Ops.prefixOps = store.OpsFilter.prefixOps.filter(
          (v: any) => v.name.indexOf(val) > -1
        );
      });
      break;
    default:
      break;
  }
}

watch(
  () => changeNameData.prefix,
  () => {
    if (changeNameData.prefix !== prefixChange.value) {
      submitDisable.value = false;
    } else {
      submitDisable.value = true;
    }
  }
);

watch(
  () => changeNameData.firstName,
  () => {
    if (changeNameData.firstName !== firstNameChange.value) {
      submitDisable.value = false;
    } else {
      submitDisable.value = true;
    }
  }
);

watch(
  () => changeNameData.lastName,
  () => {
    if (changeNameData.lastName !== lastNameChange.value) {
      submitDisable.value = false;
    } else {
      submitDisable.value = true;
    }
  }
);
</script>

<template>
  <div class="text-primary row q-mb-sm">
    <q-btn
      round
      flat
      color="primary"
      dense
      icon="add"
      @click="
        () => {
          changeNameData.prefix = profileInfo.prefix;
          changeNameData.firstName = profileInfo.firstName;
          changeNameData.lastName = profileInfo.lastName;
          prefixChange = changeNameData.prefix;
          firstNameChange = changeNameData.firstName;
          lastNameChange = changeNameData.lastName;
          changeNameData.status = '';
          dialogStatus = 'create';
          submitDisable = true;
          dialog = true;
        }
      "
    >
      <q-tooltip>เพิ่มข้อมูล</q-tooltip></q-btn
    >

    <q-space />
    <q-input
      dense
      outlined
      label="ค้นหา"
      class="q-mr-sm"
      v-model="filterSearch"
    >
      <template v-slot:append>
        <q-icon name="search" />
      </template>
    </q-input>

    <q-select
      dense
      multiple
      outlined
      emit-value
      map-options
      options-cover
      options-dense
      option-value="name"
      style="min-width: 150px"
      v-model="visibleColumns"
      :options="columns"
      :display-value="$q.lang.table.columns"
    />
  </div>

  <d-table
    flat
    dense
    bordered
    virtual-scroll
    ref="table"
    v-bind="attrs"
    v-model:pagination="pagination"
    :rows="rows"
    :columns="columns"
    :filter="filterSearch"
    :rows-per-page-options="[10, 25, 50, 100]"
    :visible-columns="visibleColumns"
    :virtual-scroll-sticky-size-start="48"
  >
    <template v-slot:header="props">
      <q-tr :props="props">
        <q-th v-for="col in props.cols" :key="col.name" :props="props">
          <span class="text-weight-medium">{{ col.label }}</span>
        </q-th>
        <q-th auto-width />
      </q-tr>
    </template>

    <template v-slot:body="props">
      <q-tr :props="props" class="cursor-pointer">
        <q-td v-for="(col, index) in props.cols" :key="col.name">
          <div class="table_ellipsis">
            {{ col.value }}
          </div>
        </q-td>
        <q-td auto-width>
          <q-btn
            color="green"
            flat
            dense
            round
            size="14px"
            icon="mdi-file-document-outline"
            @click="fetchProfile(props.row.id)"
          >
            <q-tooltip>ดาวน์โหลด</q-tooltip>
          </q-btn>
          <q-btn
            color="primary"
            flat
            dense
            round
            class="q-mr-xs"
            size="14px"
            icon="mdi-pencil-outline"
            clickable
            @click="
              () => {
                editForm(props.row);
              }
            "
          >
            <q-tooltip>แก้ไขข้อมูล</q-tooltip>
          </q-btn>
          <q-btn
            color="info"
            flat
            dense
            round
            size="14px"
            icon="mdi-history"
            @click="
              () => (fetchHistoryData(props.row.id), (historyDialog = true))
            "
          >
            <q-tooltip>ดูประวัติการเปลี่ยนชื่อ-นามสกุล</q-tooltip>
          </q-btn>
          <!-- <q-btn
            color="red"
            flat
            dense
            round
            size="14px"
            icon="mdi-delete"
            clickable
            @click.stop="deleteData(props.row.id), deleteFileData(props.row.id)"
            v-close-popup
          >
            <q-tooltip>ลบข้อมูล</q-tooltip>
          </q-btn> -->
        </q-td>
      </q-tr>
    </template>
  </d-table>

  <q-dialog v-model="dialog" persistent>
    <q-card>
      <q-form @submit.prevent greedy @validation-success="onSubmit()">
        <dialog-header
          :tittle="dialogStatus === 'edit' ? 'แก้ไขข้อมูล' : 'เพิ่มข้อมูล'"
          :close="closeDialog"
        />
        <q-separator color="grey-4" />

        <q-card-section style="max-height: 50vh" class="scroll">
          <div class="row q-mb-sm">
            <div class="col-5">
              <q-select
                outlined
                v-model="changeNameData.status"
                :options="statusOption"
                label="สถานะการเปลี่ยนชื่อ"
                use-input
                hide-bottom-space
                input-debounce="0"
                :rules="[
                  (val) => !!val || `${'กรุณาเลือกสถานะการเปลี่ยนชื่อ'}`,
                ]"
                @filter="(inputValue:string,
                    doneFn:Function) => filterSelector(inputValue, doneFn,'statusOptions'
                    ) "
                dense
              />
            </div>
          </div>
          <div class="row q-gutter-sm q-mb-md">
            <div class="col">
              <q-select
                :readonly="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ และชื่อ' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และนามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                "
                v-model="changeNameData.prefix"
                :options="store.Ops.prefixOps"
                label="คำนำหน้าชื่อ"
                dense
                :class="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ และชื่อ' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และนามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                    ? ''
                    : 'inputgreen'
                "
                outlined
                use-input
                lazy-rules
                emit-value
                map-options
                :rules="[(val) => !!val || `${'กรุณาเลือกคำนำหน้าชื่อ'}`]"
                hide-bottom-space
                input-debounce="0"
                option-label="name"
                option-value="name"
                @filter="(inputValue:string,
                    doneFn:Function) => filterSelector(inputValue, doneFn,'prefixOps'
                    ) "
              />
            </div>
            <div class="col">
              <q-input
                :readonly="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ และชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนชื่อ-นามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                "
                outlined
                v-model="changeNameData.firstName"
                label="ชื่อ"
                bg-color="white"
                dense
                :class="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนคำนำหน้าชื่อ และชื่อ' &&
                    changeNameData.status !== 'เปลี่ยนชื่อ-นามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                    ? ''
                    : 'inputgreen'
                "
                :rules="[(val) => !!val || `${'กรุณากรอกชื่อ'}`]"
                hide-bottom-space
              />
            </div>
            <div class="col">
              <q-input
                :readonly="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนนามสกุล' &&
                    changeNameData.status !== 'เปลี่ยนชื่อ-นามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และนามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                "
                outlined
                v-model="changeNameData.lastName"
                label="นามสกุล"
                bg-color="white"
                dense
                :class="
                  !changeNameData.status ||
                  (changeNameData.status !== 'เปลี่ยนนามสกุล' &&
                    changeNameData.status !== 'เปลี่ยนชื่อ-นามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และนามสกุล' &&
                    changeNameData.status !==
                      'เปลี่ยนคำนำหน้าชื่อ และชื่อ-นามสกุล')
                    ? ''
                    : 'inputgreen'
                "
                :rules="[(val) => !!val || `${'กรุณากรอกนามสกุล'}`]"
                hide-bottom-space
              />
            </div>
          </div>
          <div class="row">
            <q-uploader
              color="gray"
              type="file"
              flat
              ref="uploader"
              class="full-width"
              text-color="white"
              :max-size="10000000"
              accept=".jpg,.png,.pdf,.csv,.doc,.docx"
              bordered
              label="[ไฟล์ jpg,png,pdf,csv,doc,docx ขนาดไม่เกิน 10MB]"
              @added="(v) => (fileUpload = v[0])"
            >
              <template v-slot:header="scope">
                <div class="row no-wrap items-center q-pa-sm q-gutter-xs">
                  <q-btn
                    v-if="scope.queuedFiles.length > 0"
                    icon="clear_all"
                    @click="scope.removeQueuedFiles"
                    round
                    dense
                    flat
                  >
                    <q-tooltip>ลบทั้งหมด</q-tooltip>
                  </q-btn>
                  <q-btn
                    v-if="scope.uploadedFiles.length > 0"
                    icon="done_all"
                    @click="scope.removeUploadedFiles"
                    round
                    dense
                    flat
                  >
                    <q-tooltip>ลบไฟล์ที่อัปโหลด</q-tooltip>
                  </q-btn>
                  <q-spinner
                    v-if="scope.isUploading"
                    class="q-uploader__spinner"
                  />
                  <div class="col">
                    <div class="q-uploader__title">
                      {{ "[ไฟล์ jpg,png,pdf,csv,doc,docx ขนาดไม่เกิน 10MB]" }}
                    </div>
                    <div class="q-uploader__subtitle">
                      {{ scope.uploadSizeLabel }} /
                      {{ scope.uploadProgressLabel }}
                    </div>
                  </div>
                  <q-btn
                    v-if="scope.canAddFiles"
                    type="a"
                    icon="add_box"
                    @click="scope.pickFiles"
                    round
                    dense
                    flat
                  >
                    <q-uploader-add-trigger />
                    <q-tooltip>เลือกไฟล์</q-tooltip>
                  </q-btn>
                  <q-btn
                    v-if="scope.isUploading"
                    icon="clear"
                    @click="scope.abort"
                    round
                    dense
                    flat
                  >
                    <q-tooltip>ยกเลิกการอัปโหลด</q-tooltip>
                  </q-btn>
                </div>
              </template>
            </q-uploader>
            <div
              v-if="alertUpload && dialogStatus === 'create'"
              class="row text-negative items-center q-mt-sm"
            >
              กรุณาอัพโหลดเอกสาร
              <q-icon name="mdi-alert-circle q-ml-sm" size="24px" />
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right">
           <q-btn
              id="onSubmit"
              type="submit"
              dense
              :disable="submitDisable"
              unelevated
              label="บันทึก"
              color="public"
              class="q-px-md"
              @click="
                () => {
                  if (!!fileUpload && dialogStatus === 'create') {
                    alertUpload = false;
                  } else {
                    alertUpload = true;
                  }
                }
              "
            >
              <q-tooltip>บันทึกข้อมูล</q-tooltip>
            </q-btn>
        </q-card-actions> 
      </q-form>
    </q-card>
  </q-dialog>
  

  <q-dialog v-model="historyDialog" class="dialog" persistent>
    <q-card  style="min-width: 70%">
      <dialog-header
            tittle="ประวัติแก้ไขการเปลี่ยนชื่อ-นามสกุล"
            :close="closeHistoryDialog"
          />
      <q-separator />

      <q-card-section style="max-height: 50vh" class="scroll">
        <q-toolbar style="padding: 0px" class="text-primary q-mb-sm">
          <q-space />
          <q-input
            dense
            outlined
            bg-color="white"
            v-model="historyKeyword"
            label="ค้นหา"
            class="q-mr-sm"
          >
            <template v-slot:append>
              <q-icon name="search" />
            </template>
          </q-input>

          <q-select
            v-model="historyVisibleColumns"
            multiple
            outlined
            dense
            bg-color="white"
            options-dense
            :display-value="$q.lang.table.columns"
            emit-value
            map-options
            :options="historyColumns"
            option-value="name"
            options-cover
            style="min-width: 150px"
          />
        </q-toolbar>
        <d-table
          ref="table"
          :columns="historyColumns"
          :rows="historyRows"
          row-key="name"
          flat
          bordered
          :paging="true"
          dense
          :filter="historyKeyword"
          v-model:pagination="historyPagination"
          :rows-per-page-options="[20, 50, 100]"
          class="custom-header-table"
          :visible-columns="historyVisibleColumns"
        >
          <template v-slot:header="props">
            <q-tr :props="props">
              <q-th v-for="col in props.cols" :key="col.name" :props="props">
                <span class="text-weight-medium">{{ col.label }}</span>
              </q-th>
              <q-th auto-width />
            </q-tr>
          </template>
          <template v-slot:body="props">
            <q-tr :props="props" class="cursor-pointer">
              <q-td v-for="col in props.cols" :key="col.id">
                <div>
                  {{ col.value === "" ? "-" : col.value }}
                </div>
              </q-td>
              <q-td auto-width> </q-td>
            </q-tr>
          </template>
        </d-table>
      </q-card-section>
    </q-card>     
  </q-dialog>
</template>

<style scoped></style>
